/* makeSubConnect2.cc
--------------------------------------------------------------------------
 V2 եޥåȥǡ sub_connect ե롢ϥǥåե롢
 üֹüֹбɽץ
--------------------------------------------------------------------------
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXLENGTH 256

// 饹 MakeSubConnect 
class MakeSubConnect {

 protected:
  int* Net_no;                                     /* ƻʬֹ */
  int* Ep_u_no;                                  /* ή¦üֹ */
  int* Ep_d_no;                                  /* ή¦üֹ */
  int* Ep_u_info;                          /* ή¦üΰ־ */
  int* Ep_d_info;                          /* ή¦üΰ־ */
  int* sigma_up;                   /* ήüܤƤƻʬ */
  int* sigma_down;                 /* ή¦ܤƤƻʬ */
  int** mu_up;                 /* ή¦ܤƤƻʬֹ */
  int** mu_down;               /* ή¦ܤƤƻʬֹ */
  int up_inside;                         /* ޳ˤήü */
  int up_online;                             /* վˤήü */
  int down_inside;                       /* ޳ˤ벼ήü */
  int down_online;                           /* վˤ벼ήü */
  int Num_of_Seg;                                    /* ƻʬ */
  int xMapNo;                                       /* Ͽֹ(x) */
  int yMapNo;                                       /* Ͽֹ(y) */
  int subNetNo;                                        /* ֹ */

 public:
  // 󥹥ȥ饯
  MakeSubConnect(char* file_in);
  // plain format V2 ΥǡȤݤͤǼ롣

  MakeSubConnect(void){}

  // ǥȥ饯
  ~MakeSubConnect(void);

 protected:
  void Set_value(void);
  // ѰդͤǼ롣

  int Set_names
    // ֥̾ꤹ롣
    (
     int x,                // X  Map Number
     int y,                // Y  Map Number
     int no,               // ֹ
     char file_out[],      // ϥǡå̾
     char subsys_obname[], // ʬϥ֥̾
     char slpelm_obname[], // ǥ֥̾
     char netelm_obname[], // ƻǥ֥̾
     char p_filename[],    // ̥߱ǡե̾
     char e_fileneme[]     // ȯ̥ǡե̾
     );

 public:
  void OutputSubConnectFile
    (
     char* file_out, 
     char* file_tab,
     char* file_idx
     );
  // sub_connect ե롢ֹбɽϥǥåեϤ롣

};

// 󥹥ȥ饯
MakeSubConnect :: MakeSubConnect(char* file_in)
{
  FILE* fp_in;
  char buf[256];
  int n_seg;
  int i;
  int X, Y, SubNo, net_no, ep_no, ep_info;

  if((fp_in = fopen(file_in, "r")) == NULL){
    printf("MakeSubConnect\n");
    printf("Cannot open input file.\n");
    exit(1);
  }

  while(fgets(buf, 256, fp_in) != NULL){

    // Ͽֹ롣
    if(strcmp(buf, "[Map Number]\n") != 0) continue;
    else {
      if(fgets(buf, 256, fp_in) != NULL){
	if(sscanf(buf, "%d %d", &X, &Y) != 2){
	  printf("Cannot scan Map Number.\n");
	  exit(1);
	}
	xMapNo = X;
	yMapNo = Y;
	break;
      }
    }
  }
  // ƻʬ롣
  while(fgets(buf, 256, fp_in) != NULL){
    if(strcmp(buf, "[Number of River Segments]\n") != 0) continue;
    else {
      if(fgets(buf, 256, fp_in) != NULL){
	if(sscanf(buf, "%d", &n_seg) != 1){
	  printf("Cannot scan 'Num_of_Seg'.\n");
	  exit(1);
	}
	Num_of_Seg = n_seg;
	
	/* γ */
	Net_no = new int[Num_of_Seg];
	Ep_u_no = new int[Num_of_Seg];
	Ep_d_no = new int[Num_of_Seg];
	Ep_u_info = new int[Num_of_Seg];
	Ep_d_info = new int[Num_of_Seg];
	sigma_up = new int[Num_of_Seg];
	sigma_down = new int[Num_of_Seg];
	mu_up = new int*[Num_of_Seg];
	mu_down = new int*[Num_of_Seg];
	break;
      }
    }
  }

  // ֹ롣
  while(fgets(buf, 256, fp_in) != NULL){
    if(strcmp(buf, "[Sub-network Number]\n") != 0) continue;
    else {
      if(fgets(buf, 256, fp_in) != NULL){
	if(sscanf(buf, "%d", &SubNo) != 1){
	  printf("Cannot scan Sub-network No.\n");
	  exit(1);
	}
	subNetNo = SubNo;
	break;
      }
    }
  }

  /* ͤγǼ */
  while(fgets(buf, 256, fp_in) != NULL){
    // [Data]õ
    if(strcmp(buf, "[Data]\n") != 0) continue;
    else {
      // [Data]ˤ
      i = 0;                      // βƻʬֹ(Net_no[i]i)
      while(fgets(buf, 256, fp_in) != NULL){
	if(i == Num_of_Seg){
	  printf("Too many information.\n");
	  exit(1);
	}
	if(sscanf(buf, "%d %d %d %d %d",
		  &X, &Y, &ep_no, &net_no, &ep_info) != 5){
	  printf("Cannot scan Data.\n");
	  exit(1);
	}
	// ƻʬֹǼ
	Net_no[i] = net_no;
	if(ep_no > 0){
	  // ή¦ü
	  Ep_u_no[i] = ep_no;
	  Ep_u_info[i] = ep_info;
	}
	else {
	  // ή¦ü
	  Ep_d_no[i] = -ep_no;
	  Ep_d_info[i] = ep_info;
	}
	// βƻʬΤ⤦üõ
	while(fgets(buf, 256, fp_in) != NULL){
	  if(sscanf(buf, "%d %d %d %d %d",
		    &X, &Y, &ep_no, &net_no, &ep_info) != 5){
	    printf("Cannot scan Data.\n");
	    exit(1);
	  }
	  if(ep_info == -1) continue;         // ü
	  else if(ep_no > 0){
	    // ή¦ü
	    Ep_u_no[i] = ep_no;
	    Ep_u_info[i] = ep_info;
	    //  i 򥤥󥯥ȡ
	    i++;
	    break;
	  }
	  else{
	    // ή¦ü
	    Ep_d_no[i] = -ep_no;
	    Ep_d_info[i] = ep_info;
	    //  i 򥤥󥯥ȡ
	    i++;
	    break;
	  }
	}
      }
    }
  }
  fclose(fp_in);
  Set_value();
}


// ǥȥ饯
MakeSubConnect :: ~MakeSubConnect(void)
{
  delete [] Net_no;
  delete [] Ep_u_no;
  delete [] Ep_d_no;
  delete [] Ep_u_info;
  delete [] Ep_d_info;
  for(int i = 0; i < sigma_up[i]; i++){
    delete [] mu_up[i];
  }
  for(int j = 0; j < sigma_down[j]; j++){
    delete [] mu_down[j];
  }
  delete [] mu_up;
  delete [] mu_down;
  delete [] sigma_up;
  delete [] sigma_down;
}


// sigma, mu ͤǼ޳ξ塦ήüڤӡվξ塦ήü
// 򥫥Ȥ롣
void MakeSubConnect :: Set_value(void)
{
  int u_counter, d_counter;
  int u_in_counter = 0, d_in_counter = 0;
  int u_on_counter = 0, d_on_counter = 0;
  int i, j;

  up_inside = 0;
  up_online = 0;
  down_inside = 0;
  down_online = 0;

  // sigma_up, sigma_down ͤǼmu_up, mu_down 
  for(i = 0; i < Num_of_Seg; i++){
    u_counter = -1;
    d_counter = -1;
    
    for(j = 0; j < Num_of_Seg; j++){
      if((Ep_u_no[i] == Ep_u_no[j]) || (Ep_u_no[i] == Ep_d_no[j])){
	u_counter++;
      }
      if((Ep_d_no[i] == Ep_u_no[j]) || (Ep_d_no[i] == Ep_d_no[j])){
	d_counter++;
      }
    }
    
    sigma_up[i] = u_counter;
    sigma_down[i] = d_counter;

    if(sigma_up[i] == 0){
      mu_up[i] = new int[1];
    }
    if(sigma_down[i] == 0){
      mu_down[i] = new int[1];
    }
    if(sigma_up[i] != 0){
      mu_up[i] = new int[sigma_up[i]];
    }
    if(sigma_down[i] != 0){
      mu_down[i] = new int[sigma_down[i]];
    }
  }

  // ޳ξ塦ήüڤӡվξ塦ήüο򥫥
  // mu_up, mu_down ͤǼ
  for(i = 0; i < Num_of_Seg; i++){
    if((sigma_up[i] == 0) && (Ep_u_info[i] == 0)){
      // ޳ξήü
      mu_up[i][0] = u_in_counter;
      u_in_counter++;
    }
    if((sigma_down[i] == 0) && (Ep_d_info[i] == 0)){
      // ޳βήü
      mu_down[i][0] = d_in_counter;
      d_in_counter++;
    }
  }
  for(i = 0; i < Num_of_Seg; i++){
    if((sigma_up[i] == 0) && (Ep_u_info[i] != 0)){
      // վξήü
      mu_up[i][0] = u_in_counter + u_on_counter;
      u_on_counter++;
    }
    if((sigma_down[i] == 0) && (Ep_d_info[i] != 0)){
      // վβήü
      mu_down[i][0] = d_in_counter + d_on_counter;
      d_on_counter++;
    }  
  }

  up_inside = u_in_counter;
  up_online = u_on_counter;
  down_inside = d_in_counter;
  down_online = d_on_counter;

  int iup, idown;
  for(i = 0; i < Num_of_Seg; i++){
    iup = 0;
    idown = 0;
    for(j = 0; j < Num_of_Seg; j++){
      if((Ep_u_no[i] == Ep_u_no[j]) && (i != j)){
	// ήüɤ³
	mu_up[i][iup] = -Net_no[j];
	iup++;
      }
      if((Ep_u_no[i] == Ep_d_no[j]) && (i != j)){
	// ήüȲήü³
	mu_up[i][iup] = Net_no[j];
	iup++;
      }
      if((Ep_d_no[i] == Ep_u_no[j]) && (i != j)){
	// ήüȾήü³
	//mu_down[i][idown] = Net_no[j];
	mu_down[i][idown] = -Net_no[j];
	idown++;
      }
      if((Ep_d_no[i] == Ep_d_no[j]) && (i != j)){
	// ήüɤ³
	//mu_down[i][idown] = -Net_no[j];
	mu_down[i][idown] = Net_no[j];
	idown++;
      }
    }
  }
}


// ƻʬ³ե롢üֹ-üֹбɽǥåե
// Ϥ롣
void MakeSubConnect :: OutputSubConnectFile
(
 char* file_out,   // ƻʬ³ե
 char* file_tab,   // üֹ-üֹбɽ
 char* file_idx    // ʬϥǥåե
 )
{
  FILE* fp_out;
  FILE* fp_tab;
  FILE* fp_idx;
  int i, j;

  fp_out = fopen(file_out, "w");
  fp_tab = fopen(file_tab, "a");

  fprintf(fp_out, "# %s\n\n", file_out);

  for(i = 0; i < Num_of_Seg; i++){
    fprintf(fp_out, " %d : %d :", Net_no[i], sigma_up[i]);

    if(sigma_up[i] == 0){
      fprintf(fp_out, " %d (rp) :", mu_up[i][0]);
      fprintf(fp_tab, "%d %d %d %d %d (rp)\n", 
	      xMapNo, yMapNo, subNetNo, Ep_u_no[i], mu_up[i][0]);
    }
    else {
      for(j = 0; j < sigma_up[i]; j++){
	fprintf(fp_out, " %d", mu_up[i][j]);
      }
      fprintf(fp_out, " :");
    }

    fprintf(fp_out, " %d :", sigma_down[i]);

    if(sigma_down[i] == 0){
      fprintf(fp_out, " %d (sp)\n", mu_down[i][0]);
      fprintf(fp_tab, "%d %d %d %d %d (sp)\n",
	      xMapNo, yMapNo, subNetNo, Ep_d_no[i], mu_down[i][0]);
    }
    else {
      for(j = 0; j < sigma_down[i]; j++){
	fprintf(fp_out, " %d", mu_down[i][j]);
      }
      fprintf(fp_out, "\n");
    }
  }
    
  fclose(fp_out);
  fclose(fp_tab);


  // ϤȤΥǥåե롣
  char sub_name[MAXLENGTH], slp_obname[MAXLENGTH];
  char net_obname[MAXLENGTH], p_file[MAXLENGTH];
  char e_file[MAXLENGTH];

  int lateral_unit = 3;
  int slp_obno = 0;
  int net_obno = 0;

  if(Set_names(xMapNo, yMapNo, subNetNo, file_out, sub_name,
	      slp_obname, net_obname, p_file, e_file) < 0){
    printf("Cannot set Names.\n");
    exit(1);
  }

  fp_idx = fopen(file_idx, "a");

  fprintf(fp_idx, "%s %d %d %d %d %s %d %d %s %d %s %d %s %s\n",
	  sub_name, up_inside, up_online, down_inside,
	  down_online, file_out, lateral_unit, Num_of_Seg,
	  slp_obname, slp_obno, net_obname, net_obno, 
	  p_file, e_file); 

  fclose(fp_idx);
}


// ʬϡǡƻǤΥ̡֥̾߱ȯ̥ǡ
// Υե̾ꤹ롣
int MakeSubConnect :: Set_names
(
 int x,
 int y,
 int no,
 char file_out[],      // ϥǡå̾
 char subsys_obname[], // ʬϥ֥̾
 char slpelm_obname[], // ǥ֥̾
 char netelm_obname[], // ƻǥ֥̾
 char p_filename[],    // ̥߱ǡե̾
 char e_filename[]     // ȯ̥ǡե̾
 )
{
  int i, n; 
  char string[2];
  char data[100];

  // . 鲿ʸܤˤ뤫Ĵ٤롣
  for (i=strlen(file_out)-1; i >= 0; i--) {  
    string[0] = file_out[i];
    string[1] = '\0';
    n = i;
    if (string[0] == '.') {
      break;
    }
  }
  if (n == 0) { // ϥե̾ . ޤޤƤʤ
    return (-1);
  }
  // ʬϥ֥̾ꤹ롣
  for (i=0; i < n; i++) { 
    subsys_obname[i] = file_out[i];
    data[i] = file_out[i];
  }
  subsys_obname[i] = '\0';
  data[i] = '\0';

  strcpy(p_filename, data);
  strcpy(e_filename, data);

  strcat(p_filename, ".rain");        // ߱ǡ̾
  strcat(e_filename, ".evapo");       // ȯǡ̾

  
  // ǥ֥̾ꤹ롣
  char slp[20];
  char channel[20];
  char X[10], Y[20], No[20];

  sprintf(X, "%d", x);
  sprintf(Y, "%d", y);
  sprintf(No, "%d", no);

  strcpy(slp, "syamen-");  // ǤΥ֥̾ syamen- Ϥޤ롣
  strcpy(channel, "net-"); // ƻǤΥ֥̾ net- 顣
  
  strcat(slp, X);
  strcat(channel, X);

  strcat(slp, "-");
  strcat(channel, "-");

  strcat(slp, Y);
  strcat(channel, Y);

  strcat(slp, "-");
  strcat(channel, "-");

  strcat(slp, No);
  strcat(channel, No);

  strcpy(slpelm_obname, slp);
  strcpy(netelm_obname, channel);


  return (1);
}


int Set_output_filename
// ϥǡå̾ꤹ롣ϥǡå̾ϥǡå
// κǸ˽ФƤԥꥪɰʹߤ .sub ֤ΤȤ롣
// ȤСϥǡå̾
//
//     daidogawa.test-1-1-1.dat
//
// ξ硢ϥǡå̾
//
//     daidigawa.test-1-1-1.sub
//
// Ȥʤ롣Ǥ 1 򡢥顼 -1 ֤
(
 char input_filename[],  // ϥǡå̾
 char output_filename[] // ϥǡå̾(Sub-Connect file ̾)
 )
{
  int i, n; 
  char string[2];

  // . 鲿ʸܤˤ뤫Ĵ٤롣
  for (i=strlen(input_filename)-1; i >= 0; i--) {  
    string[0] = input_filename[i];
    string[1] = '\0';
//    printf("%d %s\n", i, string);
    n = i;
    if (string[0] == '.') {
      break;
    }
  }
  if (n == 0) { // ϥե̾ . ޤޤƤʤ
    return (-1);
  }
  // ϥǡå̾ꤹ롣
  for (i=0; i <= n; i++) { 
    output_filename[i] = input_filename[i];
  }
  output_filename[i] = '\0';
  strcat(output_filename, "sub");
  return (1);
}

/*-------------------------
   ᥤץ
-------------------------*/

int main(
	 int argc,            // θĿ
	 char* argv[]         // ʸ
	 )
{
  if (argc != 1 && argc != 4) {
    printf("Usage : makeSubConnect snf2DataFileName ep-prtTableName");
    printf(" indexFileName\n");
    exit(1);
  }

  char input_filename[MAXLENGTH];   // sub-network format V2 Υǡå
  char output_filename[MAXLENGTH];  // ƻʬ³ե
  char table_filename[MAXLENGTH];   // üֹ-üֹбɽ
  char index_filename[MAXLENGTH];   // ʬϥǥåե

  if (argc == 1){
    printf("# sub-network file (*.snf2) : ");
    scanf("%s", input_filename);
    printf("# table file : ");
    scanf("%s", table_filename);
    printf("# index file : ");
    scanf("%s", index_filename);
  }

  else {
    sscanf(argv[1], "%s", input_filename);
    sscanf(argv[2], "%s", table_filename);
    sscanf(argv[3], "%s", index_filename);
  }

  // Sub-Connect ե̾
  if (Set_output_filename(input_filename, output_filename) < 0){
    printf("Input dataset name is wrong !  Exit program.\n");
    exit(1);
  }

  MakeSubConnect Test
    (
     input_filename           // ʬϤȤ V2 format ǡե
     );

  Test.OutputSubConnectFile
    (
     output_filename,         // ƻʬ³ե(Sub-Connect file) 
     table_filename,          // üֹüֹбɽ (~.tab)
     index_filename           // ϤȤξ򵭽Ҥե (~.idx)
     );

}
